/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// catchaction.cpp Mon Jul 23 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "catchaction.h"

CatchAction::CatchAction()
{
    setDirection(Angle(0));
}

CatchAction::~CatchAction()
{
}

ServerCommand* CatchAction::translate() const
{
    CatchCommand* pccCmd;

    pccCmd = new CatchCommand( aCatchDir );

    return pccCmd;
}

Action* CatchAction::copy() const
{
    return new CatchAction(*this);
}
	
void CatchAction::setDirection(const Angle& _aCatchDir)
{
    aCatchDir = _aCatchDir;
}

Angle CatchAction::getDirection() const
{
    return aCatchDir;
}


ostream& CatchAction::ostream_insert(ostream& _out) const
{
    _out << "CatchAction";
    return _out;
}

ofstream& CatchAction::ofstream_insert(ofstream& _fout) const
{
    _fout << "catchaction";
    return _fout;
}

