/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// turnaction.cpp Thu Jun 21 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "turnaction.h"
#include "turncommand.h"

TurnAction::TurnAction() : Action()
{
}

TurnAction::TurnAction(const Angle &_aDirection) : Action()
{
	setDirection(_aDirection);
}

TurnAction::~TurnAction()
{
}

Action* TurnAction::copy() const
{
	return new TurnAction(*this);
}

ServerCommand* TurnAction::translate() const
{
	// WARNING: remember to delete this!
	TurnCommand *ptcCmd = new TurnCommand(getDirection());
	
	return ptcCmd;
}

void TurnAction::setDirection(const Angle &_aDirection)
{
	aDirection = _aDirection;
}

Angle TurnAction::getDirection() const
{
	return aDirection;
}

ostream& TurnAction::ostream_insert(ostream& _out) const
{
    _out << "TurnAction (" << getDirection() << ")" << endl;

    return _out;
}
ofstream& TurnAction::ofstream_insert(ofstream& _fout) const
{
    // TODO: Implement XML

    return _fout;
}
