/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// coachcontrol.h Thu Jun 28 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef COACHCONTROL_H
#define COACHCONTROL_H

#include "eyeonaction.h"
#include "debug.h"
#include "recommendation.h"
#include "action.h"
#include "coachworldmodel.h"
#include "behavior.h"
#include "perception.h"
#include "body.h"
#include "identitydata.h"

#include <iostream.h>
#include <strstream.h>
#include <stdlib.h>

/**The coach
  *@author UVa RoboCup Team
  */

class CoachControl {
public: 
	CoachControl(char* _pcTeamname, const char* _pcHostName, int _iPort, int _iReconnectNumber);
	~CoachControl();
	
	void coach();
	void listen();

private:
	// filestream for logging
    ofstream ofCoach;

   	Behavior* pbeBehaviors[NUM_BEHAVIORS];
//	Perception* pperPerceptions[NUM_PERCEPTIONS];
	
	CoachWorldModel cwmWorld;
	Body bdBody;



};

#endif
