/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// dashcommand.cpp Fri Jun 22 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "dashcommand.h"

#undef TRACE
#define TRACE(cmd)

DashCommand::DashCommand() : ServerCommand(1)
{
}

DashCommand::DashCommand(double _dPower) : ServerCommand(1)
{
	setPower(_dPower);
}

DashCommand::~DashCommand()
{
}

Comm& DashCommand::comm_insert(Comm &_cmConnection) const
{
		double dTempPower = dPower;

    if (dTempPower < MINPOWER - EPS)
    {
        TRACE("servertime_here"
              << " PlayerComm: agent tries to send (dash " << dTempPower
              << "), normalizing to " << MINPOWER );
        dTempPower = MINPOWER;
    }
    else if (dTempPower > MAXPOWER + EPS)
    {
        TRACE("servertime_here"
              << " PlayerComm: agent tries to send (dash " << dTempPower
              << "), normalizing to " << MAXPOWER );
        dTempPower = MAXPOWER;
    }
    else if (! ( (dTempPower >= MINPOWER - EPS) &&
                 (dTempPower <= MAXPOWER + EPS) ) )
    {
        // NaN ?
        TRACE("servertime_here"
              << " PlayerComm: agent tries to send (dash " << dTempPower
              << "), dropping command completely" );
        return _cmConnection;
    }

    char msg [MAX_SERVER_MSG_SIZE];
    sprintf(msg, "(dash %f)", dTempPower);
    if (_cmConnection.sendToServer(msg) == COMM_OK)
    {
        TRACE("PlayerComm: agent sent " << msg);
    }
    else
    {
        ALERT("servertime_here"
              << " PlayerComm: agent cannot send " << msg << " to server" );
    }
		
		return _cmConnection;
}

void DashCommand::setPower(double _dPower)
{
	dPower = _dPower;
}

double DashCommand::getPower() const
{
	return dPower;
}
