//////////////////////////////////////////////////////////////////////
// Mainz Rolling Brains RoboCup agents developed for the Simulator
// League of the RoboCup 2000 competition
//
// Copyright (C) 1998, 1999, 2000 Team Members
// of the Mainz Rolling Brains RoboCup Team
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//-*- c++ -*-/////////////////////////////////////////////////////////
//
//  $Id: parser.h,v 1.4 2001/06/28 21:24:08 jmm9gc Exp $
//
//  parser.h - parsing of server messages
//
//////////////////////////////////////////////////////////////////////


#ifndef _PARSER_H_
#define _PARSER_H_

#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <iostream.h>

#include "constants.h"
// #include "sensor.h"
// #include "coordinates.h" // for DEG_TO_RAD()
#include "angle.h"

#include "audiodata.h"
#include "coachdata.h"
#include "identitydata.h"
#include "physicaldata.h"
#include "visualdata.h"

class Parser
{
public:

    Parser();
		Parser(const char *_team, int _number, playing_side _side, bool _isCoach);

    virtual ~Parser();

    void setStates(const char *team,
                   int number,
                   playing_side _side,
                   bool _isCoach);

    SensorData* parseServerString(const char *s);

    play_mode parsePlayMode(const char *s);


private:

    char *team;
    int number;
    playing_side side;
    bool isCoach; // true if see info is received as coach data (exact)

    bool parseVisual(const char *s, VisualData &data);
    bool parseCoach(const char *s, CoachData &data);
    bool parseAudio(const char *s, AudioData &data);
    bool parsePhysical(const char *s, PhysicalData &data);
    bool parseGoalScore(const char *s, int &score);

    void makeValid(SensorObject &obj,
                   double dist, double dir,
                   double dist_change, double dir_change);

// VOID: No real difference between ExactObjects and SensorObjects
// VOID: Changed to typedef for readability
    void makeValid(ExactObject &obj,
                   double x, double y,
                   double x_vel, double y_vel);

};

#endif
