/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// actionlist.h Fri Jul 20 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _ACTIONLIST_H_
#define _ACTIONLIST_H_

#include "action.h"
#include <list>
#include <iostream>

class Action;

class ActionList
{
public:
	ActionList();
	ActionList(const ActionList& alOther);
    ~ActionList();
    Action* front() const;
	void pop_front();
	void insert(const Action& _acAction);
	bool empty() const;	
	//Action* operator[](unsigned int i) const;
	unsigned int size() const;
	void clear();
  	ActionList& operator=(const ActionList &alOther);
    // ActionList merge(const ActionList& al) const;
	ofstream& ofstream_insert(ofstream& _fout) const;
	ostream& ostream_insert(ostream& _out) const;

private:
	list<Action*> lActionPtrs;
};

ofstream& operator<<(ofstream& _fout, const ActionList& _alList);
ostream& operator<<(ostream& _out, const ActionList& _alList);


#endif
