/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// backlineperception.cpp Fri Jul 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "backlineperception.h"

BackLinePerception::BackLinePerception(const WorldModel &_wmWorld): Perception(_wmWorld)
{
}

BackLinePerception::~BackLinePerception()
{
}


bool BackLinePerception::isBehindBall ()
{
	if ( wmWorld.getClientPlayer().getAbsPosition().getX() <  getBallAbsPos().getX() )
		return true;
	
	return false;
		
}

Vector2d BackLinePerception::getBallAbsPos()
{
//returns the absolute position of the ball
return wmWorld.getWorldBall().getAbsPosition();
}

double BackLinePerception::distToBallX () const
{
	//get the distance of the client player to the ball	
	return  ( wmWorld.getWorldBall().getAbsPosition().getX() - wmWorld.getClientPlayer().getAbsPosition().getX() );
}

Angle BackLinePerception::getBodyDir()
{
 	return ( wmWorld.getClientPlayer().getBodyDir() );
}


int BackLinePerception::getBallAge() const
{
	return ( wmWorld.getWorldBall().getAge() );
}

bool BackLinePerception::isActiveMode() const
{
  play_mode pmTemp = wmWorld.getPlayMode();
  
  if( (pmTemp == PLAY_MODE_PLAY_ON) ||
      (pmTemp == PLAY_MODE_DROP_BALL) ||
      (pmTemp == PLAY_MODE_KICK_IN_US) ||
      (pmTemp == PLAY_MODE_KICK_IN_THEM) ||
      (pmTemp == PLAY_MODE_GOALIE_CATCH_US) ||
      (pmTemp == PLAY_MODE_FREE_KICK_US) ||
      (pmTemp == PLAY_MODE_GOAL_KICK_US) ||
      (pmTemp == PLAY_MODE_OFFSIDE_THEM)) 
    {
      return true;
    }
  
  return false;
}

bool BackLinePerception::slowRun() const
{
    play_mode pmTemp = wmWorld.getPlayMode();
    if( (pmTemp == PLAY_MODE_KICK_IN_US) ||
	(pmTemp == PLAY_MODE_KICK_IN_THEM)
      ) return true;

    return false;
}
