/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// catchperception.cpp Mon Jul 23 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "catchperception.h"

const int CatchPerception::OLD_AGE = 3;

CatchPerception::CatchPerception(const WorldModel& _wmWorld) : Perception(_wmWorld)
{
}

CatchPerception::~CatchPerception()
{
}

bool CatchPerception::isActiveMode() const
{
    play_mode pmTemp = wmWorld.getPlayMode();
    if( (pmTemp == PLAY_MODE_PLAY_ON)
      ) return true;

    return false;
}

bool CatchPerception::isCatchable() const
{
    bool fCatchable = false;
    Vector2d vToBall = relPos(wmWorld.getWorldBall());
    Vector2d vBall = wmWorld.getWorldBall().getVelocity ();
    Vector2d vBallPredict = vToBall + vBall;
    
    if(fabs(vBallPredict.getX()) < CATCHABLE_AREA_L)
        fCatchable = true;

    if( fCatchable && (fabs(vBallPredict.getY()) < CATCHABLE_AREA_W))
      {
        return true;
      }

    return false;
}

Angle CatchPerception::catchAngle() const
{
  Vector2d vToBall = relPos(wmWorld.getWorldBall());
  return vToBall.getAngle();
}

bool CatchPerception::inOurPenaltyArea() const
{
  Vector2d vAbsPos = wmWorld.getClientPlayer().getAbsPosition();
  
  return ( ( vAbsPos.getX() > - 0.5 * FIELD_LENGTH ) &&
	   ( vAbsPos.getX() < - 0.5 * FIELD_LENGTH + PENALTY_AREA_LENGTH ) &&
	   ( fabs( vAbsPos.getY() ) < 0.5 * PENALTY_AREA_WIDTH ) );
}

bool CatchPerception::isBallOld() const
{
    return (wmWorld.getWorldBall().getAge() > OLD_AGE);
}
