/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// crossperception.cpp Sat Aug 4 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "crossperception.h"

CrossPerception::CrossPerception(const WorldModel &_wmWorld) : Perception(_wmWorld)
{
}

CrossPerception::~CrossPerception()
{
}

bool CrossPerception::isActiveMode () const
{
  play_mode pmTemp = wmWorld.getPlayMode();
  
  return (pmTemp == PLAY_MODE_CORNER_KICK_US
	  || pmTemp == PLAY_MODE_PLAY_ON
	  || pmTemp == PLAY_MODE_DROP_BALL
	  || pmTemp == PLAY_MODE_FREE_KICK_US
	  || pmTemp == PLAY_MODE_KICK_IN_US);
}

bool CrossPerception::inCrossingArea () const
{
  Vector2d vPlayerPos = wmWorld.getClientPlayer().getAbsPosition();

  if (vPlayerPos.getX() > (FIELD_LENGTH / 2.0) - 10.0)
    {
      return fabs (vPlayerPos.getY()) > 25.0;
    }

  return false;  
}

# if 0
int CrossPerception::teammateClosestTo (Vector2d &vLoc)
{
  double dDist = INFINITY;
  int closestsofar = -1;

  for (int i = 1; i <= MAX_PLAYER; i++)
    {
      wpPlayer = wmWorld.getOurPlayer(i);
      
      if (wpPlayer.isKnown())
	{
	  double dThisDistance = dist (wpPlayer, vLoc);
	  
	  if (dThisDistance < dDist)
	    {
	      closestsofar = i;
	      dDist = dThisDistance;
	    }
	}
    }

  return closestsofar;
}

# endif

Angle CrossPerception::angleToKick() const
{
  Vector2d vSpot ((FIELD_LENGTH * 0.5) - 14.0, 0.0);

  Angle aKick;
  aKick = relPos(vSpot).getAngle();
  return aKick;
}


