/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// kickoffbehavior.cpp Wed Jul 11 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "kickoffbehavior.h"
#include "turnaction.h"

KickoffBehavior::KickoffBehavior(const WorldModel& _wmWorld) : perKickoff(_wmWorld)
{
}

KickoffBehavior::~KickoffBehavior()
{
}

bool KickoffBehavior::isUseful()
{
    return (perKickoff.isActiveMode() && !perKickoff.atPosition());
}

void KickoffBehavior::evaluate(RecommendationList& recList)
{
    Recommendation recFinal;

    MoveAction maMove;

    maMove.setPosition( perKickoff.getMyKickoffPos() );

    recFinal.addAction(maMove);
    recFinal.setGrade(100); // Must go to position!

    recFinal.szBehaviorName = "kickoff";

    recList.insert(recFinal);
}
