/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// perception.h Fri Jun 8 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _PERCEPTION_H_
#define _PERCEPTION_H_

#include "worldmodel.h"
//#include "polygon.h"

class Perception 
{
public:
     Perception(const WorldModel& wmWorld);
	~Perception();

	Vector2d relPos(const WorldObject &_woObject) const;
	Vector2d relPos(const Vector2d &_vAbsPos) const;
	Angle getMyFaceDir();
	Angle getBodyDir();
	int getTime() const;
	bool atBall() const;
	bool ballTooOld (int age = 3) const;
	bool amIClosestToBall (int nth = 2) const;
	bool correctViewMode(const view_width vw, const view_quality vq) const;
	Angle getTurnMoment(const Angle &aDirection) const;
	possession_state getPossession() const;
	double dist (const WorldObject& _woObj1, const WorldObject& _woObj2) const;

	double getStamina() const;
protected:
	const WorldModel& wmWorld;

};

#endif
