
/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// goalkickbehavior.h Tue Jul 24 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef PUNTBEHAVIOR_H
#define PUNTBEHAVIOR_H

#include "behavior.h"
#include "puntperception.h"
#include "kickaction.h"
#include "moveaction.h"
#include "turnaction.h"

/**Behavior to allow goalie to act
reasonably after catching the ball.
  *@author UVa RoboCup Team
  */

class PuntBehavior : public Behavior  {
public: 
	PuntBehavior(const WorldModel& _wmWorld);
	virtual ~PuntBehavior();
	
    virtual bool isUseful();
	virtual void evaluate(RecommendationList& recList);	
	
private:
    PuntPerception perPunt;
    bool fSentTurn;
    int iMoveCount;
    int iTimeCaught;


};

#endif
