/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// coachdata.cpp Thu Jun 14 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "coachdata.h"

CoachData::CoachData()
{
    exactball.valid = false;
    for (int i=0; i<22; i++)
        exactplayer[i].valid = false;

    setTime(UNKNOWN);

}

CoachData::CoachData(int _time) : SensorData(_time)
{
    exactball.valid = false;
    for (int i=0; i<22; i++)
        exactplayer[i].valid = false;
    setTime(_time);
}

CoachData::~CoachData()
{
}

CoachWorldModel& CoachData::worldmodel_insert(CoachWorldModel& _cwmWorld) const
{
    _cwmWorld.setTime(time);

    if (exactgoal[0].team == TEAM_US)
	{
		_cwmWorld.setOurGoal(exactgoal[0]);
		_cwmWorld.setOtherGoal(exactgoal[1]);
	}
	else if (exactgoal[0].team == TEAM_THEM)
	{
		_cwmWorld.setOurGoal(exactgoal[1]);
		_cwmWorld.setOtherGoal(exactgoal[0]);
	}
	else
	{
		TRACE("A goals exists that corresponds to no team.");
	}


    // Set the world ball
    _cwmWorld.updateWorldBall(exactball);

    // then copy each player into the worldmodel
	for(int i = 0; i < NUM_PLAYERS; i++)
	{
		_cwmWorld.updatePlayer(exactplayer[i]);
	}
	
	


  return _cwmWorld;
}
