/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// identitydata.cpp Wed Jun 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "identitydata.h"
#include "clientworldplayer.h"

IdentityData::IdentityData()
{
	team_name = NULL;
	side = SIDE_UNKNOWN;
  number = UNKNOWN;
  type = CLIENT_UNKNOWN;	

  pmMode = PLAY_MODE_UNKNOWN;
}

IdentityData::IdentityData(int _time) : SensorData(_time)
{
	team_name = NULL;
	side = SIDE_UNKNOWN;
  number = UNKNOWN;
  type = CLIENT_UNKNOWN;	
}

WorldModel& IdentityData::worldmodel_insert(WorldModel& _wmWorld) const
{
	// in order to have easy access to the client player
	// WorldModel needs to know the client's jersey number
	// see worldmodel.cpp and worldmodel.h for more information
	_wmWorld.setClientPlayerNum(number);
	
	_wmWorld.setTeamName(team_name);
	
	if(pmMode != PLAY_MODE_UNKNOWN)
	    _wmWorld.setPlayMode(pmMode);
	
	// TODO: figure out a better way to do modify client player
	//			 this method violates demeter's law.
	ClientWorldPlayer* pcwpClient = _wmWorld.modifyClientPlayer();
	
	ENSURE(pcwpClient != NULL);
	
	pcwpClient->setNumber(number);
	pcwpClient->setPlayingSide(side);
/*	
	if (side == SIDE_LEFT)
	{
		// set our goal to left, their goal to right
		_wmWorld.setOurGoal(GOAL_LEFT);
		_wmWorld.setOtherGoal(GOAL_RIGHT);
	}
	else if (side == SIDE_RIGHT)
	{
		_wmWorld.setOurGoal(GOAL_RIGHT);
		_wmWorld.setOtherGoal(GOAL_LEFT);		
	}
	else
	{
		ALERT("The client player does not know what goal to shoot for!!");
	}
*/	
	if (type == CLIENT_GOALIE) pcwpClient->setGoalie(true);
	
	return _wmWorld;
}

CoachWorldModel& IdentityData::worldmodel_insert(CoachWorldModel& _cwmWorld) const
{
	_cwmWorld.setTeamName(team_name);
		
	return _cwmWorld;
}

IdentityData::~IdentityData()
{
//	if (team_name != NULL)
//		delete team_name;
}
