/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// physicaldata.h Wed Jun 13 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef PHYSICALDATA_H
#define PHYSICALDATA_H

#include <iostream.h>

#include "sensordata.h"
#include "worldmodel.h"

class PhysicalData : public SensorData
{
public: 
	PhysicalData();
	PhysicalData(int _time);
	virtual ~PhysicalData();

  // from sensor.h
  // then following valid if type == SENSOR_TYPE_SENSE_BODY
  view_width my_view_width;
  view_quality my_view_quality;
  double stamina;
  double effort;
  double speed;        // radius of speed vector
  double speed_angle;  // angle of speed vector, as given by server
  double head_angle;
  int kick_count;
  int dash_count;
  int turn_count;
  int say_count;
  int turn_neck_count;

  ostream& ostream_insert(ostream &sout) const;
	WorldModel& worldmodel_insert(WorldModel &_wmWorld) const;
};

// ostream& operator<<(ostream& sout, const PhysicalData &d);
#endif
