/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// clientworldplayer.h Thu Jun 28 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _CLIENTWORLDPLAYER_H_
#define _CLIENTWORLDPLAYER_H_

#include "worldplayer.h"

class ClientWorldPlayer : public WorldPlayer
{
public: 
	ClientWorldPlayer();
	virtual ~ClientWorldPlayer();
	void setFaceDir(Angle aFaceDir);
	virtual Angle getFaceDir() const;
	virtual Angle getBodyDir() const;
    int getKickCount() const;
	int getDashCount() const;
	int getSayCount() const;
	int getTurnCount() const;
	int getTurnNeckCount() const;
	view_quality getViewQuality() const;
	view_width getViewWidth() const;
    playing_side getPlayingSide() const;
	
    void setKickCount(int _iKickCount);
	void setDashCount(int _iKickCount);
	void setSayCount(int _iKickCount);
	void setTurnCount(int _iKickCount);
	void setTurnNeckCount(int _iKickCount);
	void setPlayingSide(playing_side _plsSide);
	void setViewQuality(view_quality _vqViewQuality);
	void setViewWidth(view_width _vwViewWidth);
	
    virtual ofstream& ofstream_insert(ofstream& _out);
	
private:
	Angle aFaceDir;
  view_width vwViewWidth;
  view_quality vqViewQuality;
	
	// command counts
	int iKickCount;
	int iDashCount;
	int iTurnCount;
	int iSayCount;
	int iTurnNeckCount;	
	
	playing_side plsSide; 	

};

#endif
